/*  UPDATE CGI program example */
PhoneFile = 'PHONE DATA'          /* File of phone number data      */
DataDir   = 'SFSTEST:VMWEBCD.WEBSHARE.DATA' /* data file location   */
parm.=''                          /* Initialize default values      */
 
'callpipe (end %)',
       '*:',                      /* Read input from the form       */
      '|  xlate 1-* 05 40',       /* Convert any tab chars to space */
      '|  strip',                 /* Ignore any empty ones          */
      '|  locate 1',
      '|  xlate fieldsep = f1 upper',  /* Upper case field name     */
      '|f:fanout',
      '|  specs "=PARM.?" 1 1-* next', /* Put it in varload format  */
      '|  varload',
      '%f:',
      '|  chop before string "="',     /* Save just the field name  */
      '|  join * " "',                 /* Make 1 string of names    */
      '|  var parm.?0'
 
FormVars  = parm.?0
FormError = 0
Do while FormVars <> ''           /* Go through all form variables  */
   Parse var FormVars onevar FormVars
   onevar = '?'||onevar
   If parm.onevar = '' Then Do    /* Are any of them blank?         */
      FormError = 1               /* If so - issue an error message */
      Leave
   End
End
 
Select
/* Any field missing? */
  When FormError Then Do
    Update = '<B>not successful</B>.'
    Reason = 'The failure was due to a blank or missing input field. '
    Action = 'Please <A HREF="../update.html">return</A> to the',
             'update screen and resubmit your update.'
  End
  When parm.?version /== '1.2' Then Do
    Update = '<B>not successful</B>.'
    Reason = 'You have an old or incorrect level of the input form.'
    Action = 'Please <A HREF="../update.html">return</A> to the',
             'update screen and reload the form.'
  End
  Otherwise
    RC = UpdateFile()
 
    If RC = 0 Then Do
       Update = 'successful.'
       Reason = 'Thank you for keeping your records up to date!'
       Action = ''
    End
    Else Do
       Update = '<B>not successful</B>.'
       Reason = 'The failure was due to a program error.'
       Action = 'Please notify system support.'
    End
End
 
/* HTML document to output to tell the user if their update  */
/* worked or failed.  Also, give them a link to go to.       */
out.1 ='<HTML><HEAD>'
out.2 ='<TITLE>ITSO Telephone Update</TITLE>'
out.3 ='</HEAD><BODY>'
out.4 ='<H1>ITSO Telephone Update</H1>'
out.5 ='<P>Your update was' Update '</P>'
out.6 ='<P>' Reason Action '</P>'
out.7 ='<P><A HREF="phone2">Return to the telephone',
       'number table.</A></P>'
out.8 ='<HR>'
out.9 ='<B>{'
out.10='<A HREF="home.html">Home Page</A> |'
out.11='<A HREF="http://www.ibm.com">IBM Home Page</A> |'
out.12='<A HREF="http://w3.ibm.com/">IBM Intranet</A>'
out.13='}</B>'
out.14='</BODY></HTML>'
out.0=14
 
'callpipe stem out. | *:'
 
Exit RC
 
UpdateFile:
/* Update the file                                                  */
/* Create a record with the data entered onto the form              */
UpdateLine = left(parm.?empnum,6) left(parm.?name,20),
             left(parm.?phone,12) left(parm.?location,3),
             left(parm.?office,9) left(parm.?status,5)
 
'callpipe (end ?)',                 /* Update the file              */
         '<sfs' PhoneFile DataDir,
      '|c:strfind "*"',             /* Put all comments at the top  */
      '|f:fanin',
      '|  >sfs' PhoneFile Datadir,
      '?c:',
      '|  preface var UpdateLine',  /* Add in the update            */
      '|  sort unique 1.6',         /* Keep only 1 employee number  */
      '|f:'
Return RC
